package com.jpattern.orm.datasource;

import com.jpattern.orm.exception.OrmException;
import com.jpattern.orm.session.ISessionStrategy;
import com.jpattern.orm.session.ISqlPerformerStrategy;
import com.jpattern.orm.transaction.ITransaction;
import com.jpattern.orm.transaction.ITransactionDefinition;

/**
 * 
 * @author Francesco Cina
 *
 * 21/mag/2011
 */
public class DataSourceSessionStrategy implements ISessionStrategy {

	private final DataSourceSessionProvider dataSourceSessionProvider;

	public DataSourceSessionStrategy(DataSourceSessionProvider dataSourceSessionProvider) {
		this.dataSourceSessionProvider = dataSourceSessionProvider;
	}

	@Override
	public ITransaction getTransaction(ITransactionDefinition transactionDefinition) throws OrmException {
		return new DataSourceTransaction(dataSourceSessionProvider, transactionDefinition);
	}
	
	@Override
	public ISqlPerformerStrategy sqlPerformerStrategy() throws OrmException {
		return new DataSourceSqlPerformerStrategy( dataSourceSessionProvider);
	}

}
